Subject: Re: [netmod] Adoption poll for draft-wwx-netmod-event-yang-10

From: Alexander Clemm <[email-masked]>
Date: Mon, 4 Jan 2021 17:55:08 +0000

Hi all,

First of all, happy New Year!

My 2 cents: I can see that ECAs can be a slippery slope that can lead to significant complexity when not careful.  That said, I do think there is value in simple automation on the device, things like TCAs etc, and (looking back at history) RMON and event MIB were useful at least to some.  If we resist from trying to make this very "general" but keep it simple, I think the same can be the case here.  We certainly should not get into complex processing/actions that would require exception handling or such, but things like "send a custom notification with data D if X happens and condition C holds" would seem useful.  So, I do think it is worthwhile to pursue this and not shut it down, but I agree that we need to moderate this in a way that it focuses on the stuff that is "simple".  

--- Alex

-----Original Message-----
From: netmod <[email-masked]> On Behalf Of tom petch
Sent: Wednesday, December 30, 2020 4:50 AM
To: 'Juergen Schoenwaelder' <[email-masked]>; 'Andy Bierman' <[email-masked]>; [email-masked]
Cc: 'NetMod WG Chairs' <[email-masked]>; 'NETMOD Group' <[email-masked]>
Subject: Re: [netmod] Adoption poll for draft-wwx-netmod-event-yang-10

From: netmod <[email-masked]> on behalf of Adrian Farrel <[email-masked]>
Sent: 29 December 2020 16:26

Hi Juergen,

What you say about learning lessons from the past is wise and valuable.

Sadly (well, it's a good thing, really) we have new people in the IETF and the memory of events over the last 20 years are not immediately accessible to them. Others, who are old and grey, have been around that long but were not necessarily involved in previous ECA discussions.

Since "intent-based networking" is a big thing once again (see recent reports of acquisitions in this sector) the excitement about ECA may be forgiven, but it would help to ground the discussions if those who can remember previous efforts would share their experiences or at least some pointers.

<tp>
Adrian,
Reading Juergen's post I thought of the work of the DISMAN WG back in 2002/2003 which produced MIBs for alarms, events, alarm reporting and such like.  I thought it a great idea which chimed with proprietary work I had seen a few years earlier but the IETF work seemed not to catch on.  Randy was active in that while Juergen could say whether or not it was the kind of thing he had in mind.

With hindsight, I suspect that Andy's point about complexity of implementation was a factor.

Tom Petch

Best,
Adrian

-----Original Message-----
From: netmod <[email-masked]> On Behalf Of Juergen Schoenwaelder
Sent: 23 December 2020 18:09
To: Andy Bierman <[email-masked]>
Cc: NetMod WG Chairs <[email-masked]>; NETMOD Group <[email-masked]>
Subject: Re: [netmod] Adoption poll for draft-wwx-netmod-event-yang-10

On Wed, Dec 23, 2020 at 07:05:44AM -0800, Andy Bierman wrote:
> On Wed, Dec 23, 2020 at 3:14 AM tom petch <[email-masked]> wrote:
>
> > From: netmod <[email-masked]> on behalf of Dhruv Dhody < 
> > [email-masked]>
> > Sent: 21 December 2020 17:12
> >
> > Hi Lou, WG,
> >
> > I find the motivation in the Introduction to be focused on ECA at 
> > the network devices (with all the talk about issues with Centralized 
> > network management).
> >
> > I see the value of ECA on the controller as well, say a customer 
> > network controller or an orchestrator can set the ECA on a central 
> > controller (reference ACTN in TEAS WG). Perhaps you would consider 
> > adding a sentence to describe this as well. The client-server 
> > terminology in the rest of the document covers it already.
> >
> > And I do see value in this and support adoption.
> >
> > <tp>
> > My take is that the I-D is unclear on what ECA is.
> >
> > ECA has been worked on in at least two IETF WG AFAICT.  It cropped 
> > up in I2RS but as I recall, it was along the lines of 'This is ECA'  
> > 'No It is not'  'Yes it is' which gave me the impression that ECA is 
> > not a well-defined, or well-understood, term.
> >
> > More recently, I2NSF have produced a YANG capability-data-model 
> > which is
> > 55 pages of ECA.  Lacking a definition in this netmod I-D, I am 
> > unclear what the relationship is between the I2NSF I-D and the 
> > netmod I-D,
whether
> > or not they are using ECA in the same sense.
> >
> >
> Hi Tom,
>
> It usually helps to agree on the problem-space before focusing on the 
> solution-space.
> ECA seems like a methodology (ala MVC) more than anything else.
> The problem statement seems to be that some client tasks need to be
handled
> on the
> server using ECA methodology, instead of on the client.
> Which tasks? Seems to be any task of arbitrary purpose or complexity.
> And now the scope is supposed to include controllers (just another
client),
> so the problem-stmt
> is even less clear.
>
> The traditional approach is to pick specific client tasks to move to 
> the server.
> The example of detecting and reporting route-flaps has been used.
> (No ECA example of this complexity has been provided yet).
> The traditional approach would be to write a route-flap-detection YANG 
> module with some configuration, monitoring data, and notification 
> events.
>
> The generalized approach is likely to be extremely complex to 
> standardize and implement.
>

ECA work has a long 20+ year tradition in the IETF and several specifications have been published over the years by various working groups. As far as I can tell, none of them got traction in terms of signifiant deployment of interoperable implementations.

I would have hoped that the next iteration of ECA work would have started with a deep reflection about why all the previous attempts failed to gain traction and some genuine insights how to design things differently in order to improve the likelihood to have impact.

/js

--
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1 | 28759 Bremen | Germany
Fax:   +49 421 200 3103         <https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.jacobs-university.de%2F&amp;data=04%7C01%7Calex%40futurewei.com%7C0beb4699b9a0495dba0b08d8acc162c6%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637449293911549584%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=nQXdxJ7DumQoX9pPoHQgtYJ%2FiuoLaV1u6WtvKnKBqdg%3D&amp;reserved=0>

_______________________________________________
netmod mailing list
[email-masked]
https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fnetmod&amp;data=04%7C01%7Calex%40futurewei.com%7C0beb4699b9a0495dba0b08d8acc162c6%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637449293911559532%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=aacWB%2BxWlKpmsS9v%2FRSUY%2BbxWdKxUIfZRcnjjGtSQ7o%3D&amp;reserved=0

_______________________________________________
netmod mailing list
[email-masked]
https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fnetmod&amp;data=04%7C01%7Calex%40futurewei.com%7C0beb4699b9a0495dba0b08d8acc162c6%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637449293911559532%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=aacWB%2BxWlKpmsS9v%2FRSUY%2BbxWdKxUIfZRcnjjGtSQ7o%3D&amp;reserved=0

_______________________________________________
netmod mailing list
[email-masked]
https://nam11.safelinks.protection.outlook.com/?url=https%3A%2F%2Fwww.ietf.org%2Fmailman%2Flistinfo%2Fnetmod&amp;data=04%7C01%7Calex%40futurewei.com%7C0beb4699b9a0495dba0b08d8acc162c6%7C0fee8ff2a3b240189c753a1d5591fedc%7C1%7C0%7C637449293911559532%7CUnknown%7CTWFpbGZsb3d8eyJWIjoiMC4wLjAwMDAiLCJQIjoiV2luMzIiLCJBTiI6Ik1haWwiLCJXVCI6Mn0%3D%7C1000&amp;sdata=aacWB%2BxWlKpmsS9v%2FRSUY%2BbxWdKxUIfZRcnjjGtSQ7o%3D&amp;reserved=0